]> git.sesse.net Git - backup.sh/blobdiff - backup.sh
If .date becomes invalid, revert to full backup.
[backup.sh] / backup.sh
index c09d0df29059da19ca198024d1ecd9d78f2e0cf1..f054e1aae68fa9d93e875e3db4cb04a9077a9914 100755 (executable)
--- a/backup.sh
+++ b/backup.sh
@@ -11,9 +11,6 @@
 # It's a bit peculiar, but quite effective. The following is worth keeping in
 # mind when hacking:
 #
-# KISS. And by that I mean really simple. Only regular Unix commands, please
-# (but GNU extensions are used and moreutils has to be installed).
-#
 # Because of the way we run this script from cron, informational logging goes
 # to stderr and warnings and errors to stdout. This way, we get mail whenever
 # stuff fails, and other output is redirected to the log file.
@@ -28,9 +25,9 @@ computer=$1
 LOCKFILE=/home/backup/backuprun.lockfile.$computer
 confdir=/home/backup/conf/              # Configuration files
 storagedir=/backup                      # Where we keep backups
-maksantallfulle=3                       # Number of full backups
-dagermellomfulle=30                     # Days between full backups
-dagermellomfulleforfast=32              # Days between full backups for machines with fixed
+maxnumfull=3                            # Number of full backups
+daysbetweenfull=30                      # Days between full backups
+daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
                                         # full-backup date (in case the fixed day gets missed)
 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
 DATE=`date "+%Y%m%d%H%M"`               #format: touch
@@ -47,9 +44,14 @@ fi
 
 # Die more or less gracefully (at least notify user)
 die() {
-       echo `date`": Something nasty happened. Ending, and not deleting lockfile $LOCKFILE."
+       echo `date`": Something nasty happened."
+       rm $LOCKFILE
        exit 1
 }
+diemsg() {
+       echo `date`": $computer: $@"
+       die
+}
 
 # Trap C-c and kill
 trap die SIGINT SIGTERM
@@ -81,8 +83,7 @@ backup()
                # If it does not exist, whine a bit and then run date-based instead.
                if [ -s "$SNARFILE" ]; then
                        if ! scp $SNARFILE root@$computer:$incrementalsnar; then
-                               echo `date`" $computer: Could not copy .incremental.snar to $computer"
-                               die
+                               diemsg "Could not copy .incremental.snar to $computer"
                        fi
                        lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
                else
@@ -95,9 +96,6 @@ backup()
                lastcmd="--listed-incremental=$incrementalsnar"
        fi
 
-       # expand the exclude-path for use with tar
-       exf=`ssh root@$computer "ls ~/.backup/exclude"`
-
        # We try to run tar on the remote computer
        #    c create archive
        #    C change to directory first
@@ -110,16 +108,17 @@ backup()
        #    file and build a file list, respectivly.  
        TARFILE=$DATE.tmp
        TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
-               --exclude-from=$exf\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
+               --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
        echo `date`" $computer: Running $TARCMD" >&2
        eval $TARCMD > $DATE.idx
 
        if [ $? -eq 0 ] && [ -s $TARFILE ]; then
                # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
-
-               if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
-                       echo `date`" $computer: Could not copy .incremental.snar from $computer"
-                       die
+               if [ "$incrementalsnar" ]; then
+                       if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
+                               diemsg "Could not copy .incremental.snar from $computer"
+                       fi
                fi
 
                # Move tar file in place
@@ -141,30 +140,26 @@ backup()
        else
                # Something wrong happened.
                rm $TARFILE
-               echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
-               die
+               diemsg "tar failed or $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
        fi
 }
 
 # Check that the target filesystem is mounted (actually check that it's not
 # the root filesystem)
 if [ ! -d "$storagedir/$computer" ]; then
-       echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
-       die
+       diemsg "Target filesystem ($storagedir/$computer) does not exist. Aborting"
 fi
 rootfilesystem=`df -P /`
 targetfilesystem=`df -P "$storagedir/$computer"`
 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
-       echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
-       die
+       diemsg "Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
 fi
 
 echo `date`" $computer: Backing up $computer" >&2
 
 # Try to SSH to the computer without entering a password.
 if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
-       echo `date`" $computer: Could not use passwordless SSH."
-       die
+       diemsg "Could not use passwordless SSH."
 fi
 
 # Check if pigz is available
@@ -183,39 +178,33 @@ filesystems=`ssh -n root@$computer "cat /etc/fstab" \
        | awk '{ if ( $(NF-1) != "0" ) print $2}' `
 
 # Clean up our dir at this client
-if ! ssh root@$computer "rm -r ~/.backup ; mkdir -m 700 ~/.backup"; then
-       echo `date`" $computer: Could not create backup staging area at $computer:~/.backup"
-       die
+if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
+       diemsg "Could not create backup staging area at $computer:/root/.backup"
 fi
 
 # Try to copy $exclude to $computer
-if ! scp $exclude root@$computer:~/.backup/exclude > /dev/null; then
-       echo `date`" $computer: Could not copy exclude.txt to $computer"
-       die
+if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
+       diemsg "Could not copy exclude.txt to $computer"
 fi
 
 # Try to copy preeexec and postexec if they exist
 if [ -f $confdir/preexec.$computer ]; then
-       if ! scp $confdir/preexec.$computer  root@$computer:~/.backup/preexec >&2; then
-               echo `date`" $computer: Could not copy preexec.$computer to $computer:~/.backup/preexec"
-               die
+       if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
+               diemsg "Could not copy preexec.$computer to $computer:/root/.backup/preexec"
        fi
 fi
 if [ -f $confdir/postexec.$computer ]; then
-       if ! scp $confdir/postexec.$computer root@$computer:~/.backup/postexec >&2; then
-               echo `date`" $computer: Could not copy postexec.$computer to $computer:~/.backup/postexec"
-               die
+       if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
+               diemsg "Could not copy postexec.$computer to $computer:/root/.backup/postexec"
        fi
 fi
 
 # Try to run preexec if it exists
-if ! ssh root@$computer "[ ! -f ~/.backup/preexec ] || /bin/bash -x ~/.backup/preexec" >&2; then
-       echo `date`" $computer: Could not run $computer:~/.backup/preexec"
-       die
+if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
+       diemsg "Could not run $computer:/root/.backup/preexec"
 fi
 
-for filesystem in $filesystems
-do
+for filesystem in $filesystems; do
        # Remove / and $ (for Windows) for path names
        sfilesystem=`echo $filesystem | tr '\/\$' '__'`
 
@@ -226,7 +215,7 @@ do
        # Default backuplevel
        backuplevel=daglig
 
-       if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
+       if [ ! -s $storagedir/$computer/$sfilesystem/.date ]
        then
                # Take the first full backup of this filesystem on this computer
                backuplevel=full
@@ -235,17 +224,17 @@ do
 
        # Check if we want a full backup
        if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
-               fullbackup_min_for_this_machine=$dagermellomfulleforfast
+               fullbackup_min_for_this_machine=$daysbetweenfullforfixed
                if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
                        backuplevel=full
                fi
        elif [ -f $confdir/fastfullbackupdag.$computer ]; then
-               fullbackup_min_for_this_machine=$dagermellomfulleforfast
+               fullbackup_min_for_this_machine=$daysbetweenfullforfixed
                if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
                        backuplevel=full
                fi
        else
-               fullbackup_min_for_this_machine=$dagermellomfulle 
+               fullbackup_min_for_this_machine=$daysbetweenfull 
        fi
 
        if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
@@ -253,21 +242,22 @@ do
        fi
 
        # We want to be here
-       cd $storagedir/$computer/$sfilesystem/$backuplevel || die
+       cd $storagedir/$computer/$sfilesystem/$backuplevelmsg || die "$storagedir/$computer/$sfilesystem/$backuplevel does not exist"
 
        # Perform the actual backup
        backup
 
        # Check if this box has a custom number of full backups
-       if [ -f $confdir/maksfulle.$computer ] ; then
+       if [ -f $confdir/maksfulle.$computer.$sfilesystem ]; then
+               mf=$((`cat $confdir/maksfulle.$computer`+1))
+       elif [ -f $confdir/maksfulle.$computer ] ; then
                mf=$((`cat $confdir/maksfulle.$computer`+1))
        else
-               mf=$(($maksantallfulle+1))
+               mf=$(($maxnumfull+1))
        fi
 
        # Delete old full backups
-       for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
-       do
+       for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`; do
                prefix=`echo $full | sed "s/\.[^.]*$//"`
                echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
                rm $prefix*
@@ -284,9 +274,8 @@ do
 done
 
 # Try to run postexec if it exist
-if ! ssh root@$computer "[ ! -f ~/.backup/postexec ] || /bin/bash -x ~/.backup/postexec" >&2; then
-       echo `date`" $computer: Could not run $computer:~/.backup/postexec"
-       die
+if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
+       diemsg "Could not run $computer:/root/.backup/postexec"
 fi
 
 # Remove lockfile